%-----------------------------------------------------------------------
% This script calculates the number of possible edges between pairs of
% sites among the 650 potential brick sites that has a length within a
% given bin of length edgebin_length (measured in meters). The resulting
% histogram of edge lengths are given by the vector edge_histogram
%-----------------------------------------------------------------------

load site_coordinates
L=650;
edgebin_length=10000;
max_length=5000000;
edge_histogram=zeros(1,floor(max_length/edgebin_length));
l=0;
for j=1:L 
    for k=1:j-1
        l=l+1;
        edge_length=sqrt((site_coordinates(j,1)-site_coordinates(k,1))^2+(site_coordinates(j,2)-site_coordinates(k,2))^2);
        for m=1:floor(max_length/edgebin_length)
            if edge_length>=(m-1)*edgebin_length && edge_length<m*edgebin_length
                edge_histogram(m)=edge_histogram(m)+1;
            end
        end
    end
end

transition_number1=0;
for k=1:length(edge_histogram)
    transition_number1=transition_number1+edge_histogram(k)*(k*edgebin_length/100000+1)^(-2);
end

transition_number2=0;
for k=1:floor(250000/edgebin_length)
    transition_number2=transition_number2+edge_histogram(k)*(k*edgebin_length/100000+1)^(-1.1);
end