p=get(0,'ScreenSize');
POS=[p(1)+0.4*p(3) p(2)+0.1*p(4) 0.59*p(3) 0.83*p(4)];
help_fig=figure('menubar','none','NumberTitle','off','Name', ...
         'How networks are specified','position',POS,'units','normalized', ...
         'resize','off','color','w');
     
textaxes=gca;
set(textaxes,'position',[0 0 1 1],'xtick',[],'ytick',[],'xcolor','w','ycolor','w')

helptext= ...
['---------------------------------------------------------------------------------------';
 'NETWORK INSTRUCTIONS                                                                   ';
 '---------------------------------------------------------------------------------------';
 '                                                                                       ';
 'O          Pairs of sites with brick at the same time are connected by an edge.        ';
 'O=(5,10)   Pairs of sites with brick at some time in the interval (5,10) are connected ';
 '           by an edge. The numbers corresponds to iteration number or arbitrary time   ';
 '           unit.                                                                       ';
 '(dO<=2)    Pairs of sites with brick at times which differ less than or equal to 2     ';
 '           time units/iterations are connected by an edge.                             ';
 '(dO=2)     Pairs of sites with brick at times which differ exactly 2                   ';
 '           time units/iterations are connected by an edge.                             ';
 '(CO=4)     Pairs of sites with brick for which values of four or more variables        ';
 '           coincide, are connected by an edge. The genetic string is considered, not   ';
 '           time.                                                                       ';
 '                                                                                       ';
 'The instructions can be combined with the logical operators                            ';
 '---------------------------------------------------------------------------------------';
 '&          and                                                                         ';
 '%          or                                                                          ';
 '                                                                                       ';
 'Examples                                                                               ';
 '---------------------------------------------------------------------------------------';
 '(CO=4)&(dO<=1)  Pairs of sites for which four or more variables have the same value,   ';
 '                are connected by an edge. In addition, the time at which there is brick';
 '                at the two sites must differ by one time unit (iteration) or less.     ';
 '                                                                                       ';
 'Analysis of a given network (Use the lower command window)                             ';
 '---------------------------------------------------------------------------------------';
 'Component3    The third largest component is shown in blue.                            ';
 '                                                                                       ';
 'Analysis of a given network component                                                  ';
 '---------------------------------------------------------------------------------------';
 'Hubs       The node (or nodes) with largest degree within a given component is marked  ';
 '           in red. The degree is shown.                                                ';
 'C_Centers  The closeness center (or centers) of the component is marked in green.      '];



inserttext=uicontrol('style','edit','units','normalized','pos',[0 0 1 1], ...
    'horizontalalignment','left','FontName','FixedWidth','fontsize',10, ...
    'backgroundcolor',[1 1 1],'max',30,'string',helptext);