% The genetic information about a fraction "dataloss_prob" of attribute
% values is lost, in order to model the lack of archaeological information
% about some brick contexts.
for time=1:t_max
    for k=1:L
        for j=1:dna_length
            if rand<dataloss_prob
                genes(k,j,time)=-1;
            end
        end
    end
end

figure(simulate_map)

drawnow
set(see_edges,'enable','off');
set(see_edges,'string','Hide edges')
set(analyse_field,'enable','on')
set(analyse_field,'string','')
set(network_specification,'string','')
drawnow

axes(simulate_component)
cla
axes(simulate_axes)
cla
clear nodes
clear nedges

gl=dna_length;
clear G
G=zeros(L,gl+2);
count=1;
G(count,1)=seed;
G(count,2:(gl+1))=genes(seed,:,1);
G(count,gl+2)=1;
for k=1:L
    for time=2:t_max
        if V(k,4,time)==1
            count=count+1;
            G(count,1)=k;
            G(count,2:(gl+1))=genes(k,:,time);
            G(count,gl+2)=time;
        end
    end
end
A=count;
G=G(1:count,:);

component_chosen=0;

    N=zeros(A,A);
    CN=zeros(A,A);
    dphase=zeros(A,A);
    dphase_eq=zeros(A,A);

    for j=1:A
        for k=1:j-1
            m=0;
            for l=1:dna_length
                if abs(G(j,1+l)-G(k,1+l))==0 && G(j,l+1)>=0 && G(k,l+1)>=0
                    m=m+1;
                end
            end
            CN(j,k)=m;
            
        
            if abs(G(j,dna_length+2)-G(k,dna_length+2))<=dphase_max
                dphase(j,k)=1;
            end
            
            if abs(G(j,dna_length+2)-G(k,dna_length+2))==dphase_val
                dphase_eq(j,k)=1;
            end

        end
    end

    %----------------------------------------------------------------------
    %Contexts j and k are connected according to the instruction-string ss
    %----------------------------------------------------------------------
    set(yearcounter,'visible','on')
    for j=1:A
        drawnow
        fp=round(80*(j/A)^2);
        set(yearcounter,'string',num2str(fp))
        drawnow
        
        for k=1:j-1
            if eval(ss)
                N(j,k)=1;
            end
        end
    end
    
    for j=1:A
        for k=1:A
            if N(j,k)>0
                jj=G(j,1);
                kk=G(k,1);
                nedges(j,k)=line([site_coordinates(jj,1) site_coordinates(kk,1)],[site_coordinates(jj,2) site_coordinates(kk,2)],'visible','on','color','k');
            end
        end
    end  
                
    for k=1:A
        kk=G(k,1);
        if sum(N(k,:))+sum(N(:,k))>0
            nodes(k)=line('color','k','marker','.','markersize',20, ...
                'xdata',site_coordinates(kk,1),'ydata',site_coordinates(kk,2));
        else
            nodes(k)=line('color','k','marker','o','markersize',5, ...
                'xdata',site_coordinates(kk,1),'ydata',site_coordinates(kk,2));
        end
    end
    
    set(network_specification,'string',s)
    drawnow
    
    
    %----------------------------------------------------------------------
    %The properties of the constructed network N is analyzed in the below
    %file
    %----------------------------------------------------------------------
    network_properties2
    
    %----------------------------------------------------------------------
    %The results - network measures and distributions - are shown in a
    %separate window.
    %----------------------------------------------------------------------
    figure(res_fig)
    result_figure2
    
    figure(spec_fig)
    set(see_edges,'enable','on')
    % The edges of the networks are visible as default
    v_edges=1;
    set(see_edges,'string','Hide edges')

