    %----------------------------------------------------------------------
    %Identification of network components and calculation of their size
    %distribution.
    %----------------------------------------------------------------------
    
    components=zeros(A,3);
    component_nr=1;
    components(1,1)=component_nr;
    for j=2:A
        match=0;
        for k=1:j-1
            if N(j,k)==1 && match==0
                components(j,1)=components(k,1);
                match=1;
            end
            if N(j,k)==1 && match==1
                old_nr=components(k,1);
                for l=1:j-1
                    if components(l,1)==old_nr
                        components(l,1)=components(j,1);
                    end
                end
            end
        end
        if match==0
            component_nr=component_nr+1;
            components(j,1)=component_nr;
        end
    end
    component_sizes=zeros(A,1);
    for j=1:component_nr
        for k=1:A
            if components(k,1)==j
                component_sizes(j)=component_sizes(j)+1;
            end
        end
        for k=1:A
            if components(k,1)==j
                components(k,2)=component_sizes(j);
            end
        end
    end
                 
    component_sizes=sort(component_sizes,'descend');
    k=1;
    while component_sizes(k)>1
        k=k+1;
    end
    component_dist=component_sizes(1:k);
    component_number=k-1;
    if k>1
        solis=A-sum(component_dist(1:k-1));
    else
        solis=A;
    end
            
   
    size_list=components(:,2);
    size_nr=1;
    while max(size_list)>0
        [i j]=max(size_list);
        for k=1:A
            if components(k,1)==components(j,1)
                components(k,3)=size_nr;
                size_list(k)=0;
            end
        end
        size_nr=size_nr+1;
    end
    
    drawnow
    set(yearcounter,'string','84')
    drawnow
    
    %----------------------------------------------------------------------
    %Calculation of the clustering coefficient
    %----------------------------------------------------------------------

    
    n_triangles=0;
    n_triplets=0;
    l=0;
    NN=N;
    for j=1:A
        for k=1:j-1
            NN(k,j)=N(j,k);
        end
    end
    for j=1:A
        neighbor=0;
        Z=sum(NN(j,:));
        if Z>1
            m=0;
            for k=1:A
                if NN(j,k)==1
                    m=m+1;
                    neighbor(m)=k;
                end
            end
            c=0;
            for k=1:Z
                for m=k+1:Z
                    if NN(neighbor(m),neighbor(k))==1
                        n_triplets=n_triplets+1;
                        n_triangles=n_triangles+1;
                    else
                        n_triplets=n_triplets+1;
                    end
                end
            end
            l=l+1;
        end             
    end
    if l>0
        CG=n_triangles/n_triplets;
    else
        CG=0;
    end
    
    %CR=2*length(edges)/(A*(A-1));
    
    drawnow
    set(yearcounter,'string','88')
    drawnow
    
    %----------------------------------------------------------------------
    %Degree distribution
    %----------------------------------------------------------------------
    clear degree
    clear H
    clear IH
    no_dist=0;
    l=0;
    for k=1:A
        if sum(N(k,:))+sum(N(:,k))>0
            l=l+1;
            degree(l)=sum(N(k,:))+sum(N(:,k));
        end
    end
    if l>0
        Mean_degree=sum(degree)/l;
    else
        Mean_degree=0;
        degree=0;
    end
    if l>1
        Std_degree=sqrt(sum((degree-Mean_degree).^2)/(l-1));
    else
        Std_degree=0;
    end
    Max_degree=max(degree);
    if max(degree)>1
        H=hist(degree,[1:1:max(degree)]);
        for k=1:max(degree)
            IH(k)=sum(H(k:max(degree)));
        end
    else
        no_dist=1;
    end
    
    drawnow
    set(yearcounter,'string','92')
    drawnow
    
    %----------------------------------------------------------------------
    %Path lengths
    %----------------------------------------------------------------------
    SN=sparse(N);
    clear Distances
    for k=1:A
        [Distances(k,:),path,pred]=graphshortestpath(SN,k,'method','BFS','directed','false');
    end
    D_zero=Distances;
    l=0;
    for j=1:A
        for k=1:A
            if Distances(j,k)==inf
                D_zero(j,k)=0;
                l=l+1;
            end
        end
    end
    Diameter=max(max(D_zero));
    if A*(A-1)-l>0
        mean_path_length=sum(sum(D_zero))/(A*(A-1)-l);
    else
        mean_path_length=0;
    end
    
    drawnow
    set(yearcounter,'string','96')
    drawnow
    
    %----------------------------------------------------------------------
    %Cumulative distribution of edge lengths
    %----------------------------------------------------------------------
    clear ndd
    clear nddd
    clear cnddd
    ldd=A*(A-1)/2;
    dd=zeros(1,ldd);
    lndd=sum(sum(N));
    ndd=zeros(1,lndd);
    edgebin_length=10000;
    
    l=1;
    ll=1;
    for j=1:A
        
        drawnow
        fp=round(96+4*(j/A)^2);
        set(yearcounter,'string',num2str(fp))
        drawnow
        
        
        for k=1:j-1
            jj=G(j,1);
            kk=G(k,1);
            dd(l)=sqrt((site_coordinates(jj,1)-site_coordinates(kk,1))^2+(site_coordinates(jj,2)-site_coordinates(kk,2))^2);
            l=l+1;
            if N(j,k)==1
                ndd(ll)=sqrt((site_coordinates(jj,1)-site_coordinates(kk,1))^2+(site_coordinates(jj,2)-site_coordinates(kk,2))^2);
                ll=ll+1;
            end
        end
    end
    ddd=hist(dd,[0:edgebin_length:4000000])/length(dd);
    nddd=hist(ndd,[0:edgebin_length:4000000])/length(ndd);
    for j=1:length(nddd)
        cnddd(j)=sum(nddd(j:length(nddd)));
    end
    
% Exploration of the edge length distribution
% sd(j) is the number of possible edges within a given length bin j.
% d(j) is the number of realized edges within this length bin j for the
% chosen similarity network.
% ad(j)is the ratio of the possible edges at length j that are realized. if
% the atributes of the objects were randomly distributed among the sites,
% this ratio would be independent of edge length j.
% cad is the cumulative distribution of ad.

clear ad
clear d
clear cad

d=nddd*length(ndd);
sd=ddd*length(dd);
LLL=length(d);
for j=1:LLL
    if sd(j)>0
        ad(j)=d(j)/sd(j);
    else
        ad(j)=0;
    end
end

for j=1:LLL
    cad(j)=sum(ad(j:LLL));
    %if cad(j)<0.05
    %    cad(j)=0;
    %end
end

set(yeartext,'string','')
set(yearcounter,'string','')