clear V
clear AV
clear edges
clear N
clear genes
clear transmission
clear input_disparity
clear gene_disparity
clear experience
clear background_transmission

drawnow
set(yeartext,'visible','on','string','Wait')
set(yearcounter,'visible','on','string','0')
set(errortext,'visible','off')
set(peasanttext,'visible','on','string','soc 3:')
set(showstats,'string','Show statistics')
drawnow

V=zeros(L,4,t_max);
AV=zeros(L,4,t_max);
edges=zeros(L,L,4,t_max);
N=zeros(L,L);
add_triangles=0;

genes=zeros(L,dna_length,t_max);
transmission=zeros(L,t_max);
input_disparity=zeros(L,t_max);
gene_disparity=zeros(L,dna_length,t_max);
experience=zeros(L,1);

V(seed,1:4,1)=1;
genes(seed,:,1)=round(rand(1,24));

mutation_enhancement=0;
for time=1:t_max
    for k=1:L
        if rand<p43 && V(k,4,time)==1
            V(k,3,time)=1;
        end
        if rand<p32 && V(k,3,time)==1
            V(k,2,time)=1;
        end
        if rand<p21 && V(k,2,time)==1
            V(k,1,time)=1;
        end
        if V(k,1,time)==1
            V(k,2,time)=1;
        end
        if V(k,2,time)==1
            V(k,3,time)=1;
        end
        if V(k,3,time)==1 && V(k,2,time)==1
           V(k,4,time)=1;
        end

        background_transmission=zeros(L,1);
        foreground_transmission=zeros(L,1);

        if rand<q44 && V(k,4,time)==1
            V(k,4,time+1)=1;
            edges(k,k,4,time)=1;
            %foreground_transmission(k)=foreground_transmission(k)+1;
        end
        if rand<q33 && V(k,3,time)==1
            V(k,3,time+1)=1;
            edges(k,k,3,time)=1;
            background_transmission(k)=background_transmission(k)+1;
        end
        if rand<q22 && V(k,2,time)==1
            V(k,2,time+1)=1;
            edges(k,k,2,time)=1;
            experience(k)=experience(k)+1;
            foreground_transmission(k)=foreground_transmission(k)+1;
        else
            experience(k)=0;
        end
        if sum(edges(k,k,2:4,time))>0 && time<t_max
            genes(k,:,time+1)=genes(k,:,time+1)+genes(k,:,time);
            transmission(k,time)=transmission(k,time)+1;
        end
    
        
        
        % Reduction of transition probability because of conservatism
        if qc>0 && sum(neighbors(k,:))>0
            tn=0;
            sn=sum(neighbors(k,:));
            for q=1:L
                if neighbors(k,q)==1 && V(q,4,time)==1
                    tn=tn+1;
                end
            end
            %qn=(qc*(2*tn-1)+1)/(qc*(sn-1)+1);
            qn=(qc*(tn-1)+1)/(qc*(sn-1)+1);
        else
            qn=1;
        end
            
        dk_sum=0;
        for j=1:L
            djk=sqrt((site_coordinates(j,1)-site_coordinates(k,1))^2+(site_coordinates(j,2)-site_coordinates(k,2))^2);
            %r41=qn*c41/((djk/d011)^e11+1);
            r41=qn*c41/((1+djk/d011)^e11);
            if j~=k && V(j,4,time)==1 && rand<r41
                V(k,1,time+1)=1;
                edges(j,k,4,time)=1;
                foreground_transmission(k)=foreground_transmission(k)+1;
            end
            %r33=qn*c33/((djk/d033)^e33+1);
            r33=qn*c33/((1+djk/d033)^e33);
            if j~=k && V(j,3,time)==1 && rand<r33 && djk<d3
                V(k,3,time+1)=1;
                edges(j,k,3,time)=1;
                background_transmission(k)=background_transmission(k)+1;
            end
            %r22=qn*c22/((1+djk/d022)^e22);
            r22=qn*c22/((1+djk/d022)^e22);
            if j~=k && V(j,2,time)==1 && rand<r22 && djk<d2
                V(k,2,time+1)=1;
                edges(j,k,2,time)=1;
                foreground_transmission(k)=foreground_transmission(k)+1;
            end
            %r11=qn*c11/((djk/d011)^e11+1);
            r11=qn*c11/((1+djk/d011)^e11);
            if j~=k && V(j,1,time)==1 && rand<r11
                V(k,1,time+1)=1;
                edges(j,k,1,time)=1;
                foreground_transmission(k)=foreground_transmission(k)+1;
            end
            if sum(edges(j,k,1:4,time))>0 && time<t_max
                genes(k,:,time+1)=genes(k,:,time+1)+genes(j,:,time);
                transmission(k,time)=transmission(k,time)+1;
                dk_sum=dk_sum+djk;
            end
        end
    
        % ---------------------------------------------------------------------
        % Fixing the target site DNA as a function of the source DNA, mutating
        % target DNA with small probability, and possibly aborting the diffusion to
        % target site if DNA from several sources are disparate. The abortion
        % probability is small, and increases with disparity.
        % ---------------------------------------------------------------------
    
        % There has been successful impregnation of site k at time "time+1"
        % from "transmission(k,time)" sites.
        if transmission(k,time)>0
            genes(k,:,time+1)=genes(k,:,time+1)/transmission(k,time);
            mean_distance=dk_sum/transmission(k,time);
            for l=1:dna_length
                gene_disparity(k,l,time)=min(genes(k,l,time+1),1-min(genes(k,l,time+1)));
                input_disparity(k,time)=input_disparity(k,time)+min(genes(k,l,time+1),1-min(genes(k,l,time+1)))^2;
            end
            input_disparity(k,time)=2*sqrt(input_disparity(k,time))/sqrt(dna_length);
            for l=1:dna_length
                % Fixing target site DNA
                if genes(k,l,time+1)>0.5
                    genes(k,l,time+1)=1;
                end
                if genes(k,l,time+1)<0.5
                    genes(k,l,time+1)=0;
                end
                if genes(k,l,time+1)==0.5
                    genes(k,l,time+1)=round(rand);
                end
                
                % If brick craftsmen at social level 2 have been upholding
                % a tradtion to use bricks by local inheritance at site k
                % during "experience(k)" time steps, then the probability
                % that a mutation takes place if the brick use survives to
                % the next time step increases by the amount 
                % experience(k)*p_experience.
                %mutation_enhancement=experience(k)*p_experience;
                
                % Change of mutation probability because of conservatism
                % of brick use in the area around the receiving site
                %if mean_distance<=200000
                %    conservatism_supression=1;
                %else
                %    conservatism_supression=1;
                %end
                %qm=1;
                %same_gene=0;
                %different_gene=0;
                %if qm>0 && sum(neighbors(k,:))>0
                %     for q=1:L
                %         if neighbors(k,q)==1 && V(q,4,time)==1 && genes(q,l,time)==genes(k,l,time+1)
                %             same_gene=same_gene+1;
                %         end
                %         if neighbors(k,q)==1 && V(q,4,time)==1 && genes(q,l,time)~=genes(k,l,time+1)
                %             different_gene=different_gene+1;
                %         end
                %     end
                %end
                %if same_gene+different_gene>0
                %     conservatism_supression=1-2*qm*(0.5-different_gene/(same_gene+different_gene));
                %else
                %     conservatism_supression=1;
                %end
                
                % Mutate target site DNA
                %if rand<conservatism_supression*(p_mutation*(1+(8/pi)*(gene_disparity(k,l,time)-0.25)*atan(transmission(k,time)-1))+mutation_enhancement);
                if  rand<p_mutation*(1+(8/pi)*(gene_disparity(k,l,time)-0.25)*atan(transmission(k,time)-1)) && foreground_transmission(k)==1
                %if rand<p_mutation && foreground_transmission(k)==1
                    if genes(k,l,time+1)==1
                        genes(k,l,time+1)=0;
                    else
                        genes(k,l,time+1)=1;
                    end
                end
            
                % If the target site is impregnated ONLY from social level 3,
                % then there is an extra possibility for mutation, occurring
                % with probability "p_background".
                %if background_transmission(k)>0 && foreground_transmission(k)==0 && rand<p_background
                %    if genes(k,l,time+1)==1
                %        genes(k,l,time+1)=0;
                %    else
                %        genes(k,l,time+1)=1;
                %    end
                %end
            end
            
            
            if rand<p_reinvention && foreground_transmission(k)==1
                for l=1:dna_length
                    if rand<reinvention_fraction/100
                        if genes(k,l,time+1)==0
                            genes(k,l,time+1)=1;
                        else
                            genes(k,l,time+1)=0;
                        end
                    end
                end
            end
                   
            
            % Possible abortion of target site impregnation
            if rand<p_abortion*input_disparity(k,time);
                for count=1:4
                    V(k,count,time+1)=0;
                    for j=1:L
                        edges(j,k,count,time+1)=0;
                    end
                end
                transmission(k,time)=0;
            end
        end
    end
    
    drawnow
    set(yearcounter,'string',num2str(time))
    peasant_number=sum(V(:,3,time));
    set(peasantcounter,'string',num2str(peasant_number))
    drawnow
    
end
    
simulation_movie2

set(showall,'enable','on')
set(showstats,'enable','on')
