s='empty network';
N=zeros(L,L);

% -------------------------------------------------------------------------
% Window where simulation statistics are shown
% -------------------------------------------------------------------------
    
p=get(0,'ScreenSize');
POS=[p(1)+0.01*p(3) p(2)+0.2*p(4) 0.29*p(3) 0.73*p(4)];
stat_fig=figure('menubar','none','NumberTitle','off','Name', ...
         'Simulation statistics','position',POS,'units','normalized', ...
         'resize','off','color','w');
    
ratios_axes=axes('position',[0.13 0.67 0.83 0.28],'units','normalized','visible','off');

r2t=uicontrol(stat_fig,'style','text','units','normalized','horizontalalignment','left','visible','off', ...
        'pos',[0.12 0.55 0.65 0.05],'backgroundc','w','string','Number of brick sites','fonts',10);

homogeneity_axes=axes('position',[0.13 0.33 0.83 0.17],'units','normalized','visible','off');

sources_axes=axes('position',[0.13 0.05 0.83 0.17],'units','normalized','visible','off');

% -------------------------------------------------------------------------
% Window where network properties are shown
% -------------------------------------------------------------------------
    
p=get(0,'ScreenSize');
POS=[p(1)+0.7*p(3) p(2)+0.1*p(4) 0.29*p(3) 0.83*p(4)];
res_fig=figure('menubar','none','NumberTitle','off','Name', ...
         'Network properties','position',POS,'units','normalized', ...
         'resize','off','color','w');
     
component_axes=axes('position',[0.13 0.75 0.83 0.2],'units','normalized','visible','off');
    
r3t=uicontrol(res_fig,'style','text','units','normalized','horizontalalignment','left','visible','off', ...
        'pos',[0.12 0.64 0.65 0.03],'backgroundc','w','string','Clustering coefficient','fonts',10);
    
r7t=uicontrol(res_fig,'style','text','units','normalized','horizontalalignment','left','visible','off', ...
        'pos',[0.12 0.61 0.65 0.03],'backgroundc','w','string','Characteristic path length','fonts',10);
    
r8t=uicontrol(res_fig,'style','text','units','normalized','horizontalalignment','left','visible','off', ...
        'pos',[0.12 0.58 0.65 0.03],'backgroundc','w','string','Diameter','fonts',10);

degree_axes=axes('position',[0.13 0.36 0.83 0.18],'units','normalized','visible','off');

edge_axes=axes('position',[0.13 0.06 0.83 0.2],'units','normalized','visible','off');


%-----------------------------------------------
%figure window where map for simluation is shown
%-----------------------------------------------

load albania
load bulgaria
load greece
load italy
load turkey
load yugoslavia

p=get(0,'ScreenSize');
POS=[p(1)+0.05*p(3) p(2)+0.1*p(4) 0.9*p(3) 0.8*p(4)];
simulate_map=figure('NumberTitle','off','Name', ...
         'Fired brick networks','position',POS,'units','normalized', ...
         'resize','off','color','w');
   
hold on     
mapshow(albania)
mapshow(bulgaria)
mapshow(greece)
mapshow(italy)
mapshow(turkey)
mapshow(yugoslavia)

smap=gca;
set(smap,'xtick',[],'ytick',[],'xcolor','w','ycolor','w')
xl=get(smap,'xlim');
yl=get(smap,'ylim');
ratio=0.9*p(3)*(yl(2)-yl(1))/(0.8*p(4)*(xl(2)-xl(1)));
lp=0;
w=1-2*lp;
map_pos=[lp 0.5-ratio*w/2 w ratio*w];
set(smap,'position',map_pos)
set(smap,'color',[1 1 1])

% Markers for 100 km distances
ruler1=line([-100000 0],[4350000 4350000],'color','k');
ruler2=line([250000 350000],[4350000 4350000],'color','k');
ruler3=line([800000 900000],[4350000 4350000],'color','k');
ruler4=line([800000 900000],[4000000 4000000],'color','k');
ruler5=line([-450000 -350000],[4700000 4700000],'color','k');
ruler6=line([50000 150000],[4700000 4700000],'color','k');
ruler7=line([-150000 -50000],[4950000 4950000],'color','k');
ruler8=line([1100000 1200000],[4700000 4700000],'color','k');


simulate_axes=axes('position',map_pos,'color','none','xlim',xl,'ylim',yl,'xtick',[],'ytick',[],'xcolor','w','ycolor','w');
% Scale of distance markers
text(250000,4320000,'100 km','fontsize',7);

simulate_component=axes('position',map_pos,'color','none','xlim',xl,'ylim',yl,'xtick',[],'ytick',[],'xcolor','w','ycolor','w');

linkaxes([smap simulate_axes simulate_component],'xy')

%The existing sites are marked on the map
for k=1:L
        line('color','k','marker','o','markersize',5, ...
            'xdata',site_coordinates(k,1),'ydata',site_coordinates(k,2));
end

network_specification=uicontrol(simulate_map,'style','text','units','normalized', ...
        'pos',[0.03 0.8 0.40 0.05],'backgroundcolor','w','fonts',12, ...
	    'HorizontalAlignment','left','foregroundcolor','k','string','');

chooseseed=uicontrol(simulate_map,'style','pushbutton','units','normalized', ...
        'pos',[0.03 0.9 0.10 0.07],'backgroundcolor','w','foregroundcolor','k', ...
		'string','Choose seed','callback','choose_seed','enable','on','interruptible','on','fonts',12);

randomseed=uicontrol(simulate_map,'style','pushbutton','units','normalized', ...
        'pos',[0.13 0.9 0.10 0.07],'backgroundcolor','w','foregroundcolor','k', ...
		'string','Random seed','callback','random_seed','enable','on','interruptible','on','fonts',12);
    
showall=uicontrol(simulate_map,'style','pushbutton','units','normalized', ...
        'pos',[0.24 0.9 0.13 0.07],'backgroundcolor','w','foregroundcolor','k', ...
		'string','Show all brick sites','callback','show_all','enable','off','interruptible','on','fonts',12);

showstats=uicontrol(simulate_map,'style','pushbutton','units','normalized', ...
        'pos',[0.59 0.9 0.11 0.07],'backgroundcolor','w','foregroundcolor','k', ...
		'string','Show statistics','callback','simulation_properties2','enable','off','interruptible','on','fonts',12);
    
repeat=uicontrol(simulate_map,'style','pushbutton','units','normalized', ...
        'pos',[0.38 0.9 0.08 0.07],'backgroundcolor','w','foregroundcolor','k', ...
		'string','repeat','callback','simulation_movie2','enable','off','interruptible','on','fonts',12);
    
repeatedges=uicontrol(simulate_map,'style','pushbutton','units','normalized', ...
        'pos',[0.46 0.9 0.12 0.07],'backgroundcolor','w','foregroundcolor','k', ...
		'string','repeat with edges','callback','simulation_edgemovie','enable','off','interruptible','on','fonts',12);
    
yeartext=uicontrol(simulate_map,'style','text','units','normalized','horizontalalignment','left', ...
        'pos',[0.43 0.75 0.07 0.05],'backgroundc','w','string','','fonts',12);    
        
yearcounter=uicontrol(simulate_map,'style','text','units','normalized','horizontalalignment','left', ...
        'pos',[0.51 0.75 0.04 0.05],'backgroundc','w','string','','fonts',12);
    
peasanttext=uicontrol(simulate_map,'style','text','units','normalized','horizontalalignment','left', ...
        'pos',[0.43 0.68 0.04 0.05],'backgroundc','w','string','soc 3:','visible','off','fonts',12);    
        
peasantcounter=uicontrol(simulate_map,'style','text','units','normalized','horizontalalignment','left', ...
        'pos',[0.51 0.68 0.04 0.05],'backgroundc','w','string','','fonts',12);
    
errortext=uicontrol(simulate_map,'style','text','units','normalized','horizontalalignment','left', ...
        'pos',[0.46 0.65 0.15 0.05],'backgroundc','w','string','Try again!','fonts',12,'visible','off'); 


% ----------------------------------------------------------------
% Window where network conditions are specified by the user
% ----------------------------------------------------------------

p=get(0,'ScreenSize');
POS=[p(1)+0.01*p(3) p(2)+0.1*p(4) 0.6*p(3) 0.15*p(4)];
spec_fig=figure('menubar','none','NumberTitle','off','Name', ...
         'Network commands','position',POS,'units','normalized', ...
         'resize','off','color','w');

spec_axes=gca;
set(spec_axes,'xtick',[],'ytick',[],'xcolor','w','ycolor','w')
xl=get(spec_axes,'xlim');
yl=get(spec_axes,'ylim');
ratio=0.9*p(3)*(yl(2)-yl(1))/(0.8*p(4)*(xl(2)-xl(1)));
lp=0;
w=1-2*lp;
set(spec_axes,'position',[lp 0.5-ratio*w/2 w ratio*w])
set(spec_axes,'color',[1 1 1])


specify_text=uicontrol(spec_fig,'style','text','units','normalized', ...
        'pos',[0.03 0.6 0.20 0.22],'backgroundcolor','w','fonts',12, ...
	    'HorizontalAlignment','left','foregroundcolor','k','string','Network specification');	

spec_field=uicontrol(spec_fig,'style','edit','units','normalized', ...
      'pos',[0.24 0.6 0.36 0.2],'backgroundcolor','w','fonts',12, ...
      'enable','off','callback','s_old=s;s=get(spec_field,''string'');read_specification_string2');
  
analyse_text=uicontrol(spec_fig,'style','text','units','normalized', ...
        'pos',[0.03 0.2 0.20 0.22],'backgroundcolor','w','fonts',12, ...
	    'HorizontalAlignment','left','foregroundcolor','k','string','Network analysis');	

analyse_field=uicontrol(spec_fig,'style','edit','units','normalized', ...
      'pos',[0.24 0.2 0.36 0.2],'backgroundcolor','w','fonts',12, ...
      'enable','off','callback','as=get(analyse_field,''string'');read_analysis_string2');
  
see_edges=uicontrol(spec_fig,'style','pushbutton','units','normalized', ...
        'pos',[0.65 0.63 0.18 0.2],'backgroundcolor','w','foregroundcolor','k', ...
		'string','Hide edges','callback','view_edges2','enable','off','interruptible','on','fonts',12);	

help_button=uicontrol(spec_fig,'style','pushbutton','units','normalized', ...
        'pos',[0.87 0.2 0.1 0.2],'backgroundcolor','w','foregroundcolor','k', ...
		'string','Help','callback','help_figure2','interruptible','on','fonts',12);

% ----------------------------------------------------------------
% Window where transition probabilities are specified by the user
% ----------------------------------------------------------------

p=get(0,'ScreenSize');
POS=[p(1)+0.01*p(3) p(2)+0.1*p(4) 0.5*p(3) 0.5*p(4)];
prob_fig=figure('menubar','none','NumberTitle','off','Name', ...
         'Transition probabilities','position',POS,'units','normalized', ...
         'resize','off','color','w');

A=imread('model_export.bmp');
colormap(gray(10))
image(A)
     
prob_axes=gca;
set(prob_axes,'xtick',[],'ytick',[],'xcolor','w','ycolor','w')

soc1_text=uicontrol(prob_fig,'style','text','units','normalized', ...
      'pos',[0.03 0.765 0.1 0.06],'backgroundcolor','w','fonts',12, ...
      'string','Soc 1','horizontalalignment','left');
  
soc2_text=uicontrol(prob_fig,'style','text','units','normalized', ...
      'pos',[0.03 0.605 0.1 0.06],'backgroundcolor','w','fonts',12, ...
      'string','Soc 2','horizontalalignment','left');
  
soc3_text=uicontrol(prob_fig,'style','text','units','normalized', ...
      'pos',[0.03 0.445 0.1 0.06],'backgroundcolor','w','fonts',12, ...
      'string','Soc 3','horizontalalignment','left');

brick_text=uicontrol(prob_fig,'style','text','units','normalized', ...
      'pos',[0.03 0.28 0.1 0.06],'backgroundcolor','w','fonts',12, ...
      'string','Brick','horizontalalignment','left');

time_text=uicontrol(prob_fig,'style','text','units','normalized', ...
      'pos',[0.05 0.03 0.38 0.06],'backgroundcolor','w','fonts',12);
set(time_text,'string','Number of iterations (years/25):')

time_field=uicontrol(prob_fig,'style','edit','units','normalized', ...
      'pos',[0.43 0.03 0.06 0.06],'backgroundcolor','w','fonts',12, ...
      'callback','t_max=str2num(get(time_field,''string''));');
set(time_field,'string',15)

more_para=uicontrol(prob_fig,'style','pushbutton','units','normalized', ...
        'pos',[0.65 0.03 0.27 0.07],'backgroundcolor','w','foregroundcolor','k', ...
		'string','More parameters','callback','set(para_fig,''visible'',''on'')', ...
        'interruptible','on','fonts',12);

q22_field=uicontrol(prob_fig,'style','edit','units','normalized', ...
      'pos',[0.14 0.605 0.06 0.06],'backgroundcolor','w','fonts',12, ...
      'callback','q22=str2num(get(q22_field,''string''));');
set(q22_field,'string',0)
  
q33_field=uicontrol(prob_fig,'style','edit','units','normalized', ...
      'pos',[0.14 0.445 0.06 0.06],'backgroundcolor','w','fonts',12, ...
      'callback','q33=str2num(get(q33_field,''string''));');
set(q33_field,'string',0)
  
q44_field=uicontrol(prob_fig,'style','edit','units','normalized', ...
      'pos',[0.14 0.28 0.06 0.06],'backgroundcolor','w','fonts',12, ...
      'callback','q44=str2num(get(q44_field,''string''));');
set(q44_field,'string',0)
  
r11_field=uicontrol(prob_fig,'style','edit','units','normalized', ...
      'pos',[0.46 0.765 0.06 0.06],'backgroundcolor','w','fonts',12, ...
      'callback','c11=str2num(get(r11_field,''string''));');
set(r11_field,'string',0)
  
r22_field=uicontrol(prob_fig,'style','edit','units','normalized', ...
      'pos',[0.46 0.605 0.06 0.06],'backgroundcolor','w','fonts',12, ...
      'callback','c22=str2num(get(r22_field,''string''));');
set(r22_field,'string',0)
  
r33_field=uicontrol(prob_fig,'style','edit','units','normalized', ...
      'pos',[0.46 0.445 0.06 0.06],'backgroundcolor','w','fonts',12, ...
      'callback','c33=str2num(get(r33_field,''string''));');
set(r33_field,'string',0)
  
r41_field=uicontrol(prob_fig,'style','edit','units','normalized', ...
      'pos',[0.46 0.21 0.06 0.06],'backgroundcolor','w','fonts',12, ...
      'callback','c41=str2num(get(r41_field,''string''));');
set(r41_field,'string',0)
  
p21_field=uicontrol(prob_fig,'style','edit','units','normalized', ...
      'pos',[0.74 0.685 0.06 0.06],'backgroundcolor','w','fonts',12, ...
      'callback','p21=str2num(get(p21_field,''string''));');
set(p21_field,'string',0)
  
p32_field=uicontrol(prob_fig,'style','edit','units','normalized', ...
      'pos',[0.74 0.525 0.06 0.06],'backgroundcolor','w','fonts',12, ...
      'callback','p32=str2num(get(p32_field,''string''));');
set(p32_field,'string',0)
  
p43_field=uicontrol(prob_fig,'style','edit','units','normalized', ...
      'pos',[0.74 0.365 0.06 0.06],'backgroundcolor','w','fonts',12, ...
      'callback','p43=str2num(get(p43_field,''string''));');
set(p43_field,'string',0)


% -----------------------------------------------------------------------
% Window where further transition probabilities are specified by the user
% -----------------------------------------------------------------------

p=get(0,'ScreenSize');
POS=[p(1)+0.52*p(3)+0.01*p(3) p(2)+0.1*p(4) 0.45*p(3) 0.8*p(4)];
para_fig=figure('menubar','none','NumberTitle','off','Name', ...
         'More transition parameters','position',POS,'units','normalized', ...
         'resize','off','color','w','visible','off');


dist_text=uicontrol(para_fig,'style','text','units','normalized', ...
      'pos',[0.03 0.92 0.5 0.05],'backgroundcolor','w','fonts',14, ...
      'string','Distance function','horizontalalignment','left');

half_text=uicontrol(para_fig,'style','text','units','normalized', ...
      'pos',[0.15 0.86 0.25 0.05],'backgroundcolor','w','fonts',12, ...
      'string','Half length (km)','horizontalalignment','left');

exponent_text=uicontrol(para_fig,'style','text','units','normalized', ...
      'pos',[0.40 0.86 0.15 0.05],'backgroundcolor','w','fonts',12, ...
      'string','Exponent','horizontalalignment','left');

maximum_text=uicontrol(para_fig,'style','text','units','normalized', ...
      'pos',[0.65 0.86 0.35 0.05],'backgroundcolor','w','fonts',12, ...
      'string','Maximum distance (km)','horizontalalignment','left');

ruler_text=uicontrol(para_fig,'style','text','units','normalized', ...
      'pos',[0.03 0.80 0.1 0.05],'backgroundcolor','w','fonts',12, ...
      'string','Soc 1','horizontalalignment','left');

master_text=uicontrol(para_fig,'style','text','units','normalized', ...
      'pos',[0.03 0.74 0.1 0.05],'backgroundcolor','w','fonts',12, ...
      'string','Soc 2','horizontalalignment','left');

worker_text=uicontrol(para_fig,'style','text','units','normalized', ...
      'pos',[0.03 0.68 0.1 0.05],'backgroundcolor','w','fonts',12, ...
      'string','Soc 3','horizontalalignment','left');
  
d011_field=uicontrol(para_fig,'style','edit','units','normalized', ...
      'pos',[0.17 0.81 0.07 0.05],'backgroundcolor','w','fonts',12, ...
      'callback','d011=1000*str2num(get(d011_field,''string''));');
      set(d011_field,'string',100)
      
d022_field=uicontrol(para_fig,'style','edit','units','normalized', ...
      'pos',[0.17 0.75 0.07 0.05],'backgroundcolor','w','fonts',12, ...
      'callback','d022=1000*str2num(get(d022_field,''string''));');
      set(d022_field,'string',100)

d033_field=uicontrol(para_fig,'style','edit','units','normalized', ...
      'pos',[0.17 0.69 0.07 0.05],'backgroundcolor','w','fonts',12, ...
      'callback','d033=1000*str2num(get(d033_field,''string''));');
      set(d033_field,'string',100)
      
e11_field=uicontrol(para_fig,'style','edit','units','normalized', ...
      'pos',[0.42 0.81 0.07 0.05],'backgroundcolor','w','fonts',12, ...
      'callback','e11=str2num(get(e11_field,''string''));');
      set(e11_field,'string',-2)
      
e22_field=uicontrol(para_fig,'style','edit','units','normalized', ...
      'pos',[0.42 0.75 0.07 0.05],'backgroundcolor','w','fonts',12, ...
      'callback','e22=str2num(get(e22_field,''string''));');
      set(e22_field,'string',-1.1)

e33_field=uicontrol(para_fig,'style','edit','units','normalized', ...
      'pos',[0.42 0.69 0.07 0.05],'backgroundcolor','w','fonts',12, ...
      'callback','e33=str2num(get(e33_field,''string''));');
      set(e33_field,'string',-1.1)
      
d2_field=uicontrol(para_fig,'style','edit','units','normalized', ...
      'pos',[0.67 0.75 0.07 0.05],'backgroundcolor','w','fonts',12, ...
      'callback','d2=1000*str2num(get(d2_field,''string''));');
      set(d2_field,'string',250)

d3_field=uicontrol(para_fig,'style','edit','units','normalized', ...
      'pos',[0.67 0.69 0.07 0.05],'backgroundcolor','w','fonts',12, ...
      'callback','d3=1000*str2num(get(d3_field,''string''));');
      set(d3_field,'string',250)
      

conservatism_text=uicontrol(para_fig,'style','text','units','normalized', ...
      'pos',[0.03 0.60 0.3 0.05],'backgroundcolor','w','fonts',14, ...
      'string','Conservatism','horizontalalignment','left');

radius_text=uicontrol(para_fig,'style','text','units','normalized', ...
      'pos',[0.15 0.54 0.15 0.05],'backgroundcolor','w','fonts',12, ...
      'string','Radius (km)','horizontalalignment','left');

reduction_text=uicontrol(para_fig,'style','text','units','normalized', ...
      'pos',[0.40 0.54 0.60 0.05],'backgroundcolor','w','fonts',12, ...
      'string','Probability reduction (%)','horizontalalignment','left');
  
dc_field=uicontrol(para_fig,'style','edit','units','normalized', ...
      'pos',[0.17 0.49 0.07 0.05],'backgroundcolor','w','fonts',12, ...
      'callback','dc=1000*str2num(get(dc_field,''string''));simulation_neighbors;');
      set(dc_field,'string',20)
      
qc_field=uicontrol(para_fig,'style','edit','units','normalized', ...
      'pos',[0.42 0.49 0.07 0.05],'backgroundcolor','w','fonts',12, ...
      'callback','qc=str2num(get(qc_field,''string''))/100;');
      set(qc_field,'string',0)
      
      
genetics_text=uicontrol(para_fig,'style','text','units','normalized', ...
      'pos',[0.03 0.40 0.6 0.05],'backgroundcolor','w','fonts',14, ...
      'string','Attribute mutation and loss','horizontalalignment','left');
  
mutation_text=uicontrol(para_fig,'style','text','units','normalized', ...
      'pos',[0.15 0.34 0.25 0.05],'backgroundcolor','w','fonts',12, ...
      'string','Mutation probability','horizontalalignment','left');

pm_field=uicontrol(para_fig,'style','edit','units','normalized', ...
      'pos',[0.17 0.29 0.07 0.05],'backgroundcolor','w','fonts',12, ...
      'callback','p_mutation=str2num(get(pm_field,''string''));');
      set(pm_field,'string',0.05)
      
     
experience_text=uicontrol(para_fig,'style','text','units','normalized', ...
      'pos',[0.15 0.21 0.25 0.05],'backgroundcolor','w','fonts',12, ...
      'string','Re-invention prob.','horizontalalignment','left');
      
g_field=uicontrol(para_fig,'style','edit','units','normalized', ...
      'pos',[0.17 0.16 0.07 0.05],'backgroundcolor','w','fonts',12, ...
      'callback','p_reinvention=str2num(get(g_field,''string''));');
      set(g_field,'string',0)
      
      
reduction_text=uicontrol(para_fig,'style','text','units','normalized', ...
      'pos',[0.40 0.21 0.60 0.05],'backgroundcolor','w','fonts',12, ...
      'string','Percentage of genes changed at re-invention','horizontalalignment','left');
      
pa_field=uicontrol(para_fig,'style','edit','units','normalized', ...
      'pos',[0.42 0.16 0.07 0.05],'backgroundcolor','w','fonts',12, ...
      'callback','reinvention_fraction=str2num(get(pa_field,''string''));');
      set(pa_field,'string',40)
      
      
      
background_text=uicontrol(para_fig,'style','text','units','normalized', ...
      'pos',[0.15 0.08 0.85 0.05],'backgroundcolor','w','fonts',12, ...
      'string','Probability that attribute knowledge is lost','horizontalalignment','left');
  
pb_field=uicontrol(para_fig,'style','edit','units','normalized', ...
      'pos',[0.17 0.03 0.07 0.05],'backgroundcolor','w','fonts',12, ...
      'callback','dataloss_prob=str2num(get(pb_field,''string''));');
      set(pb_field,'string',0)
