% -----------------------------------------------------------------------
% Window where further transition probabilities are specified by the user
% -----------------------------------------------------------------------

p=get(0,'ScreenSize');
POS=[p(1)+0.52*p(3)+0.01*p(3) p(2)+0.1*p(4) 0.45*p(3) 0.5*p(4)];
para_fig=figure('menubar','none','NumberTitle','off','Name', ...
         'More transition parameters','position',POS,'units','normalized', ...
         'resize','off','color','w','visible','off');


dist_text=uicontrol(para_fig,'style','text','units','normalized', ...
      'pos',[0.03 0.9 0.5 0.06],'backgroundcolor','w','fonts',14, ...
      'string','Distance function','horizontalalignment','left');

half_text=uicontrol(para_fig,'style','text','units','normalized', ...
      'pos',[0.15 0.8 0.25 0.06],'backgroundcolor','w','fonts',12, ...
      'string','Half length (km)','horizontalalignment','left');

exponent_text=uicontrol(para_fig,'style','text','units','normalized', ...
      'pos',[0.40 0.8 0.15 0.06],'backgroundcolor','w','fonts',12, ...
      'string','Exponent','horizontalalignment','left');

maximum_text=uicontrol(para_fig,'style','text','units','normalized', ...
      'pos',[0.65 0.8 0.35 0.06],'backgroundcolor','w','fonts',12, ...
      'string','Maximum distance (km)','horizontalalignment','left');

ruler_text=uicontrol(para_fig,'style','text','units','normalized', ...
      'pos',[0.03 0.65 0.1 0.06],'backgroundcolor','w','fonts',12, ...
      'string','Soc 1','horizontalalignment','left');

master_text=uicontrol(para_fig,'style','text','units','normalized', ...
      'pos',[0.03 0.55 0.1 0.06],'backgroundcolor','w','fonts',12, ...
      'string','Soc 2','horizontalalignment','left');

worker_text=uicontrol(para_fig,'style','text','units','normalized', ...
      'pos',[0.03 0.45 0.1 0.06],'backgroundcolor','w','fonts',12, ...
      'string','Soc 3','horizontalalignment','left');
  
d011_field=uicontrol(para_fig,'style','edit','units','normalized', ...
      'pos',[0.17 0.65 0.07 0.06],'backgroundcolor','w','fonts',12, ...
      'callback','d011=1000*str2num(get(d011_field,''string''));');
      set(d011_field,'string',100)
      
d022_field=uicontrol(para_fig,'style','edit','units','normalized', ...
      'pos',[0.17 0.55 0.07 0.06],'backgroundcolor','w','fonts',12, ...
      'callback','d022=1000*str2num(get(d022_field,''string''));');
      set(d022_field,'string',100)

d033_field=uicontrol(para_fig,'style','edit','units','normalized', ...
      'pos',[0.17 0.45 0.07 0.06],'backgroundcolor','w','fonts',12, ...
      'callback','d033=1000*str2num(get(d033_field,''string''));');
      set(d033_field,'string',100)
      
e11_field=uicontrol(para_fig,'style','edit','units','normalized', ...
      'pos',[0.42 0.65 0.07 0.06],'backgroundcolor','w','fonts',12, ...
      'callback','e11=str2num(get(e11_field,''string''));');
      set(e11_field,'string',-2)
      
e22_field=uicontrol(para_fig,'style','edit','units','normalized', ...
      'pos',[0.42 0.55 0.07 0.06],'backgroundcolor','w','fonts',12, ...
      'callback','e22=str2num(get(e22_field,''string''));');
      set(e22_field,'string',-1.1)

e33_field=uicontrol(para_fig,'style','edit','units','normalized', ...
      'pos',[0.42 0.45 0.07 0.06],'backgroundcolor','w','fonts',12, ...
      'callback','e33=str2num(get(e33_field,''string''));');
      set(e33_field,'string',-1.1)
      
d2_field=uicontrol(para_fig,'style','edit','units','normalized', ...
      'pos',[0.67 0.55 0.07 0.06],'backgroundcolor','w','fonts',12, ...
      'callback','d2=1000*str2num(get(d2_field,''string''));');
      set(d2_field,'string',250)

d3_field=uicontrol(para_fig,'style','edit','units','normalized', ...
      'pos',[0.67 0.45 0.07 0.06],'backgroundcolor','w','fonts',12, ...
      'callback','d3=1000*str2num(get(d3_field,''string''));');
      set(d3_field,'string',250)

conservatism_text=uicontrol(para_fig,'style','text','units','normalized', ...
      'pos',[0.03 0.30 0.3 0.06],'backgroundcolor','w','fonts',14, ...
      'string','Conservatism','horizontalalignment','left');

radius_text=uicontrol(para_fig,'style','text','units','normalized', ...
      'pos',[0.15 0.20 0.15 0.06],'backgroundcolor','w','fonts',12, ...
      'string','Radius (km)','horizontalalignment','left');

reduction_text=uicontrol(para_fig,'style','text','units','normalized', ...
      'pos',[0.40 0.20 0.60 0.06],'backgroundcolor','w','fonts',12, ...
      'string','Probability reduction (%)','horizontalalignment','left');
  
dc_field=uicontrol(para_fig,'style','edit','units','normalized', ...
      'pos',[0.17 0.05 0.07 0.06],'backgroundcolor','w','fonts',12, ...
      'callback','dc=1000*str2num(get(dc_field,''string''));simulation_neighbors;');
      set(dc_field,'string',20)
      
qc_field=uicontrol(para_fig,'style','edit','units','normalized', ...
      'pos',[0.42 0.05 0.07 0.06],'backgroundcolor','w','fonts',12, ...
      'callback','qc=str2num(get(qc_field,''string''))/100;');
      set(qc_field,'string',0)