clear contexts
clear N
clear NN
clear R

set(yeartext,'visible','off')
set(yearcounter,'visible','off')

drawnow
set(yeartext,'visible','on','string','Wait')
set(yearcounter,'visible','off')
set(errortext,'visible','off')
    
%----------------------------------------------------------------------
% Ratio of occupied sites as a function of time
%----------------------------------------------------------------------
for time=1:t_max
    R(time,1)=sum(V(:,1,time))/L;
    R(time,2)=sum(V(:,2,time))/L;
    R(time,3)=sum(V(:,3,time))/L;
    R(time,4)=sum(V(:,4,time))/L;
end
% The total number of brick sites:
brick_sites=0;
for k=1:L
    if sum(V(k,4,:))>0
        brick_sites=brick_sites+1;
    end
end

%----------------------------------------------------------------------
% Degree of homogeneity of the genes among brick sites as a function of
% time
%----------------------------------------------------------------------

source_number=zeros(1,t_max);
homogeneity=zeros(1,t_max);
homogeneity(1,1)=1;
for time=2:t_max
    count=0;
    count2=0;
    gene_sum=zeros(1,dna_length);
    for k=1:L
        if sum(V(k,4,time))>0
            count=count+1;
            gene_sum=gene_sum+genes(k,:,time);
        end
    end
    for k=1:L
        if sum(V(k,1:4,time))>0
            count2=count2+1;
            source_number(time)=source_number(time)+transmission(k,time-1);
        end
    end
    gene_sum=gene_sum/count;
    source_number(time)=source_number(time)/count2;
    for l=1:dna_length
        homogeneity(time)=homogeneity(time)+min(gene_sum(l),1-gene_sum(l))*min(gene_sum(l),1-gene_sum(l));
    end
    homogeneity(time)=1-2*sqrt(homogeneity(time))/sqrt(dna_length);
end

set(yeartext,'visible','on','string','')
    
%----------------------------------------------------------------------
%Selected properties are plotted in the window stat_fig
%----------------------------------------------------------------------
simstat_figure2
    